function [sigma_p0i,E11_ri,E22_ri,E12_ri] = betongmatr(betongmat,imax,n,f_cd,n_eksp,v,epsilon_p0i,epsilon_c1,epsilon_c2,epsilon_c3,epsilon_cu1,epsilon_cu2,epsilon_cu3, E,sigma_p0i,E11_ri,E22_ri,E12_ri,tverrmatr,epsilon_cs)

f_ck = f_cd*1.5/0.85;
f_cm = f_ck +8;
f_cm = f_cm*0.85/1.5;


%Regner ut spenninger 
%Bestemmer hvilken material modell som skal brukes
if betongmat == 1
    %Bilinr materialmodell
    %Finner spenningene i hovedretningene
    sigma_p0i = zeros(3,n);
    if tverrmatr == 0;
        for i = 1:1:n;
            if  epsilon_p0i(1,i) < 0
                sigma_p0i(1,i) = -f_cd*(1-(1-epsilon_p0i(1,i)/epsilon_c3));
                if epsilon_p0i(1,i) <= epsilon_c3;
                    sigma_p0i(1,i) = -f_cd;
                    if epsilon_p0i(1,i) <= epsilon_cu3
                        sigma_p0i(1,i) = 0;
                    end
                end
            else
                sigma_p0i(1,i) = 0;
            end

            if  epsilon_p0i(2,i) < 0
                sigma_p0i(2,i) = -f_cd*(1-(1-epsilon_p0i(2,i)/epsilon_c3));
                if epsilon_p0i(2,i) <= epsilon_c3;
                    sigma_p0i(2,i) = -f_cd;
                    if epsilon_p0i(2,i) <= epsilon_cu3
                        sigma_p0i(2,i) = 0;
                    end
                end
            else
                sigma_p0i(2,i) = 0;
            end
        end
    elseif tverrmatr ==1;
       for i = 1:1:n;
            if  epsilon_p0i(1,i) < epsilon_cs
                sigma_p0i(1,i) = (sign(epsilon_p0i(1,i)))*f_cd*(1-(1-epsilon_p0i(1,i)/epsilon_c3));
                if epsilon_p0i(1,i) <= epsilon_c3;
                    sigma_p0i(1,i) = -f_cd;
                    if epsilon_p0i(1,i) <= epsilon_cu3
                        sigma_p0i(1,i) = 0;
                    end
                end
            else
                sigma_p0i(1,i) = 0;
            end

            if  epsilon_p0i(2,i) < epsilon_cs
                sigma_p0i(2,i) = (sign(epsilon_p0i(2,i)))*f_cd*(1-(1-epsilon_p0i(2,i)/epsilon_c3));
                if epsilon_p0i(2,i) <= epsilon_c3;
                    sigma_p0i(2,i) = -f_cd;
                    if epsilon_p0i(2,i) <= epsilon_cu3
                        sigma_p0i(2,i) = 0;
                    end
                end
            else
                sigma_p0i(2,i) = 0;
            end
        end 
    end
    %Lager ny sekantmodul for betongen
    if tverrmatr == 0;
        for i=1:1:n;
            if epsilon_p0i(1,i)>=0  
                E11_ri(i,1) = 0;
            else
                E11_ri(i,1) = (sigma_p0i(1,i))/epsilon_p0i(1,i);

            end

            if epsilon_p0i(2,i) >= 0
                E22_ri(i,1) = 0;
            else     
                E22_ri(i,1) = (sigma_p0i(2,i))/epsilon_p0i(2,i);
            end

            E12_ri(i,1) = (E11_ri(i,1)+E22_ri(i,1))/2;

        end
    elseif tverrmatr == 1;
        for i=1:1:n;
            if epsilon_p0i(1,i)>=epsilon_cs  
                E11_ri(i,1) = 0;
            else
                E11_ri(i,1) = abs((sigma_p0i(1,i))/epsilon_p0i(1,i));

            end

            if epsilon_p0i(2,i) >= epsilon_cs
                E22_ri(i,1) = 0;
            else     
                E22_ri(i,1) = abs((sigma_p0i(2,i))/epsilon_p0i(2,i));
            end

            E12_ri(i,1) = (E11_ri(i,1)+E22_ri(i,1))/2;

        end
    end
    
elseif betongmat ==2
    %Idealisert modell
    %Bestemmer spenningene i hovedretningen
    if tverrmatr == 0;
        for i = 1:1:n;
            if epsilon_p0i(1,i)<0;
                sigma_p0i(1,i) = -f_cd*(1-(1-epsilon_p0i(1,i)/epsilon_c2)^n_eksp);
                if epsilon_p0i(1,i)<epsilon_c2;
                    sigma_p0i(1,i) = -f_cd;
                    if epsilon_p0i(1,i) < epsilon_cu2
                        sigma_p0i(1,i) = 0;
                    end
                end
            else
                sigma_p0i(1,i) = 0;
            end

            if epsilon_p0i(2,i)<0;
                sigma_p0i(2,i) = -f_cd*(1-(1-epsilon_p0i(2,i)/epsilon_c2)^n_eksp);
                if epsilon_p0i(2,i)<epsilon_c2;
                    sigma_p0i(2,i) = -f_cd;
                    if epsilon_p0i(2,i) < epsilon_cu2
                        sigma_p0i(2,i) = 0;
                    end
                end
            else
                sigma_p0i(2,i) = 0;
            end
        end
    elseif tverrmatr == 1;
         for i = 1:1:n;
            if epsilon_p0i(1,i)<epsilon_cs;
                sigma_p0i(1,i) = sign(epsilon_p0i(1,i))*f_cd*(1-(1-epsilon_p0i(1,i)/epsilon_c2)^n_eksp);
                if epsilon_p0i(1,i)<epsilon_c2;
                    sigma_p0i(1,i) = -f_cd;
                    if epsilon_p0i(1,i) < epsilon_cu2
                        sigma_p0i(1,i) = 0;
                    end
                end
            else
                sigma_p0i(1,i) = 0;
            end

            if epsilon_p0i(2,i)<epsilon_cs;
                sigma_p0i(2,i) = sign(epsilon_p0i(2,i))*f_cd*(1-(1-epsilon_p0i(2,i)/epsilon_c2)^n_eksp);
                if epsilon_p0i(2,i)<epsilon_c2;
                    sigma_p0i(2,i) = -f_cd;
                    if epsilon_p0i(2,i) < epsilon_cu2
                        sigma_p0i(2,i) = 0;
                    end
                end
            else
                sigma_p0i(2,i) = 0;
            end
        end
    end

    %Oppretter ny sekant modulus for betong
    if tverrmatr == 0;
        for i=1:1:n;
            if epsilon_p0i(1,i)>=0  
                E11_ri(i,1) = 0;
            else
                E11_ri(i,1) = (sigma_p0i(1,i))/epsilon_p0i(1,i);

            end

            if epsilon_p0i(2,i) >= 0
                E22_ri(i,1) = 0;
            else     
                E22_ri(i,1) = (sigma_p0i(2,i))/epsilon_p0i(2,i);
            end

            E12_ri(i,1) = (E11_ri(i,1)+E22_ri(i,1))/2;

        end
    elseif tverrmatr == 1;
             for i=1:1:n;
                if epsilon_p0i(1,i)>= epsilon_cs  
                    E11_ri(i,1) = 0;
                else
                    E11_ri(i,1) = abs((sigma_p0i(1,i))/epsilon_p0i(1,i));

                end

                if epsilon_p0i(2,i) >= epsilon_cs
                    E22_ri(i,1) = 0;
                else     
                    E22_ri(i,1) = abs((sigma_p0i(2,i))/epsilon_p0i(2,i));
                end

                E12_ri(i,1) = (E11_ri(i,1)+E22_ri(i,1))/2;

            end
    end
elseif betongmat == 3
    
    %Ikkelinr material modell
    if tverrmatr == 0;
        
        for i = 1:n;
            if epsilon_p0i(1,i) < 0;
                eta = epsilon_p0i(1,i) / epsilon_c1;
                k = 1.05*E*abs(epsilon_c1)/f_cm;
                sigma_p0i(1,i) = -f_cm*((k*eta-eta^2)/(1+(k-2)*eta));
                if epsilon_p0i(1,i) < epsilon_cu1;
                    sigma_p0i(1,i) = 0;
                end
            else
                sigma_p0i(1,i) = 0;
            end
            if epsilon_p0i(2,i) < 0;
                eta = epsilon_p0i(2,i) / epsilon_c1;
                k = 1.05*E*abs(epsilon_c1)/f_cm;
                sigma_p0i(2,i) = -f_cm*((k*eta-eta^2)/(1+(k-2)*eta));
                if epsilon_p0i(2,i) < epsilon_cu1;
                    sigma_p0i(2,i) = 0;
                end
            else
                sigma_p0i(2,i) = 0;
            end
        end
    elseif tverrmatr == 1;
            for i = 1:n;
                if epsilon_p0i(1,i) < epsilon_cs;
                    eta = epsilon_p0i(1,i) / epsilon_c1;
                    k = 1.05*E*abs(epsilon_c1)/f_cm;
                    sigma_p0i(1,i) = sign(epsilon_p0i(1,i))*f_cm*((k*eta-eta^2)/(1+(k-2)*eta));
                    if epsilon_p0i(1,i) < epsilon_cu1;
                        sigma_p0i(1,i) = 0;
                    end
                else
                    sigma_p0i(1,i) = 0;
                end
                if epsilon_p0i(2,i) < epsilon_cs;
                    eta = epsilon_p0i(2,i) / epsilon_c1;
                    k = 1.05*E*abs(epsilon_c1)/f_cm;
                    sigma_p0i(2,i) = sign(epsilon_p0i(2,i))*f_cm*((k*eta-eta^2)/(1+(k-2)*eta));
                    if epsilon_p0i(2,i) < epsilon_cu1;
                        sigma_p0i(2,i) = 0;
                    end
                else
                    sigma_p0i(2,i) = 0;
                end
            end
    end
    %Oppretter ny sekant modulus
    if tverrmatr == 0;
        for i=1:1:n;
            if epsilon_p0i(1,i)>=0  
                E11_ri(i,1) = 0;
            else
                E11_ri(i,1) = (sigma_p0i(1,i))/epsilon_p0i(1,i);

            end

            if epsilon_p0i(2,i) >= 0
                E22_ri(i,1) = 0;
            else     
                E22_ri(i,1) = (sigma_p0i(2,i))/epsilon_p0i(2,i);
            end

            E12_ri(i,1) = (E11_ri(i,1)+E22_ri(i,1))/2;

        end
        
    elseif tverrmatr ==1;
        
        for i=1:1:n;
            if epsilon_p0i(1,i)>= epsilon_cs  
                E11_ri(i,1) = 0;
            else
                E11_ri(i,1) = abs((sigma_p0i(1,i))/epsilon_p0i(1,i));

            end

            if epsilon_p0i(2,i) >= epsilon_cs
                E22_ri(i,1) = 0;
            else     
                E22_ri(i,1) = abs((sigma_p0i(2,i))/epsilon_p0i(2,i));

            end

            E12_ri(i,1) = (E22_ri(i,1)+E11_ri(i,1))/2;

        end
    end
    
end

