function [K_s] = k_s(As,C_s,z_s)

K_sx1 = zeros(6);
K_sx2 = zeros(6);
K_sy1 = zeros(6);
K_sy2 = zeros(6);

K_sx1(1:3,1:3) = As(1)*C_s(1:3,1:3);
K_sx1(4:6,1:3) = -z_s(1)*As(1)*C_s(1:3,1:3);
K_sx1(1:3,4:6) = -z_s(1)*As(1)*C_s(1:3,1:3);
K_sx1(4:6,4:6) = (z_s(1)^2)*As(1)*C_s(1:3,1:3);

K_sx2(1:3,1:3) = As(2)*C_s(1:3,4:6);
K_sx2(4:6,1:3) = -z_s(2)*As(2)*C_s(1:3,4:6);
K_sx2(1:3,4:6) = -z_s(2)*As(2)*C_s(1:3,4:6);
K_sx2(4:6,4:6) = (z_s(2)^2)*As(2)*C_s(1:3,4:6);

K_sy1(1:3,1:3) = As(3)*C_s(1:3,7:9);
K_sy1(4:6,1:3) = -z_s(3)*As(3)*C_s(1:3,7:9);
K_sy1(1:3,4:6) = -z_s(3)*As(3)*C_s(1:3,7:9);
K_sy1(4:6,4:6) = (z_s(3)^2)*As(3)*C_s(1:3,7:9);

K_sy2(1:3,1:3) = As(4)*C_s(1:3,10:12);
K_sy2(4:6,1:3) = -z_s(4)*As(4)*C_s(1:3,10:12);
K_sy2(1:3,4:6) = -z_s(4)*As(4)*C_s(1:3,10:12);
K_sy2(4:6,4:6) = (z_s(4)^2)*As(4)*C_s(1:3,10:12);

K_s = K_sx1 + K_sx2 + K_sy1 +K_sy2;

