function [UR_vcmax] = skjarkontroll(f_cd,As,h,C1,C2,Sx,Sy,R,As_vx,As_vy,f_sd,V_x,V_y)



f_ck = f_cd*1.5/0.85;
d = h - C1 - C2;
z = 0.9*d;
V_x = V_x*1000;
V_y = V_y*1000;
b_w = 1000;
As = As*1000;


%Skjrkrefter


UR_vc(1) = 0;
UR_vcmax = 0;
for i = 1:37;
    alpha = (i-1)*5;
    V_a(i+1) = V_x*cosd(alpha) + V_y*sin(alpha);
    N_a(i) = R(1)*(cosd(alpha)^2) + R(2)*(cosd(alpha)^2) +2*R(3)*sind(alpha)*cosd(alpha);
    M_a(i) = R(4)*(cosd(alpha)^2) + R(5)*(cosd(alpha)^2) +2*R(6)*sind(alpha)*cosd(alpha);
    
    As_a(i) = (As(1)+As(2))*cosd(alpha) + (As(3)+As(4))*sin(alpha);
    As_va(i) = (As_vx*cosd(alpha) + As_vy*sind(alpha));
    S_a(i) = (Sx*cosd(alpha) + Sy*sind(alpha));
    
    if As_va(i) == 0
        k = min(1 + sqrt(200/d),2);
        rho_1 = min((As_a(i))/(b_w*d),0.02);
        if abs(R(1)) > 0;
            sigma_cp = max(N_a(i)/(b_w*h), 0.2*f_cd);
        else
            sigma_cp = 0;
        end
        k1 = 0.15;
        C_rdc = 0.18/1.5;
        v_min = (0.035*k^(3/2))*f_ck^(1/2);
        V_Rdc(i+1) = max((((C_rdc*k*((100*rho_1*f_ck)^(1/3))) + (k1*sigma_cp))*b_w*d),(v_min + (k1*sigma_cp)*(b_w*d)));
    else
        v1 = 0.6;
        f_ywd = f_sd;
        V_Rdc(i+1) = min(((As_va(i)/S_a(i))*z*f_ywd*2.5),(b_w*z*v1*f_cd/(2.9)));
    end 
    
    UR_vc(i+1) =abs((V_a(i+1)/V_Rdc(i+1)))*100;
    if UR_vc(i+1) > UR_vc(i)
        UR_vcmax = UR_vc(i+1);
    end
end

    
    
    




